#!/usr/bin/perl -w

use strict;
use Data::Dumper;
use Getopt::Std;
use Storable qw(dclone);

use vars qw ($opt_h $opt_i);
&getopts('hi:');

my $usage = <<_EOH_;

## Options ###########################################
## Required:
# -i   a file containing a list of values

## Others:
# -h   print help

_EOH_
    ;

# Get input parameters from command line
die $usage if $opt_h;
my $file    = $opt_i or die $usage;
my $tmp_dir = "/tmp/";

# Execute R
my $Rfile   = $tmp_dir . 'mean_sd.' . $$ . '.R';
my $tmp_out = $tmp_dir . 'mean_sd.' . $$ . '.out';
open(R, ">$Rfile") or die "Can't open $Rfile to write.";
print R 'data <- read.table("' . $file . '")'        . "\n"
    . 'out <- file("' . $tmp_out . '", "w")'         . "\n"
    . 'writeLines(paste(mean(data)), out, sep=" +- ")' . "\n"
    . 'writeLines(paste(sd(data)), out, sep="\n")'   . "\n"
    . 'close(out)'                                   . "\n";
close R;
`R CMD BATCH $Rfile /dev/null`;
print `cat $tmp_out`;
`rm $Rfile`;
`rm $tmp_out`;

