#!/usr/bin/perl -w

use strict;
use Data::Dumper;
use Getopt::Std;
use Storable qw(dclone);

use vars qw ($opt_h $opt_i $opt_j);
&getopts('hi:j:');

my $usage = <<_EOH_;

## Options ###########################################
## Required:
# -i   a file containing a list of values
# -j   a file containing a list of values

## Others:
# -h   print help

_EOH_
    ;

# Get input parameters from command line
die $usage if $opt_h;
my $file_1  = $opt_i or die $usage;
my $file_2  = $opt_j or die $usage;
my $tmp_dir = "/tmp/";

# Execute R
my $Rfile   = $tmp_dir . 'ttest.' . $$ . '.R';
my $tmp_out = $tmp_dir . 'ttest.' . $$ . '.out';
open(R, ">$Rfile") or die "Can't open $Rfile to write.";
print R 'data1 <- read.table("' . $file_1 . '")'        . "\n"
    . 'data2 <- read.table("' . $file_2 . '")'          . "\n"
    . 'ttest <- t.test(data1, data2)'                   . "\n"
    . 'out <- file("' . $tmp_out . '", "w")'            . "\n"
    . 'writeLines(paste(ttest$p.value), out, sep="\n")' . "\n";
close R;
`R CMD BATCH $Rfile`;
print `cat $tmp_out`;
`rm $Rfile`;
`rm $tmp_out`;
