#ifndef __INC_C_HIT_SET_H__
#define __INC_C_HIT_SET_H__

#include<map>
#include<string>
#include "hit_set.h"
#include "c_hit.h"

using namespace std;

class c_hit_set {
  map<string, c_hit> IDpair2hit;
  double min_bit, max_bit, ave_bit;
  void set_stats();
 public:
  c_hit_set(){}
  c_hit_set( hit_set& hs_12, hit_set& hs_21 );
  void add( c_hit_set c_hs );
  void insert(string ip, c_hit h);
  void erase( string ip );
  map<string, c_hit>::iterator begin(){ return IDpair2hit.begin(); }
  map<string, c_hit>::iterator end(){ return IDpair2hit.end(); }
  map<string, c_hit>::iterator find( string ip )
    { return IDpair2hit.find( ip ); }
  bool exist( string ip );
  unsigned int size() { return (unsigned int)IDpair2hit.size(); }
  double get_min_bit() { return min_bit; }
  double get_max_bit() { return max_bit; }
  double get_ave_bit() { return ave_bit; }
  double get_bit( string ip );
  void print_IDpairs();
  void clear(){ IDpair2hit.clear(); }
};

#endif // __INC_C_HIT_SET_H__
