#ifndef __INC_DPD_OPTIONS_H__
#define __INC_DPD_OPTIONS_H__

#include <iostream>
#include <string>
#include "util.h"

#ifndef DEFAULT_COL_INDEX
#define DEFAULT_COL_INDEX 1
#endif // DEFAULT_COL_INDEX
#ifndef DEFAULT_T_DPD
#define DEFAULT_T_DPD 10
#endif // DEFAULT_T_DPD
#ifndef DEFAULT_MODE
#define DEFAULT_MODE 0
#endif // DEFAULT_MODE
#ifndef INF
#define INF 0
#endif // INF

using namespace std;

class dpd_options {
  string orgname_in1;
  string orgname_in2;
  string gene_dir;
  string genefile_1;
  string genefile_2;
  string rbh_file;
  string opt_file;
  string clus_file;
  string iso_file;
  string non_iso_file;
  string detail_file;
  string stat_file;
  double col_index;
  unsigned t_dpd;
  void   set_file_name();
 public:
  dpd_options( int argc, char* argv[] );
  string get_orgname_in1() { return orgname_in1; }
  string get_orgname_in2() { return orgname_in2; }
  string get_rbh_file()    { return rbh_file; }
  string get_genefile_1()  { return genefile_1; }
  string get_genefile_2()  { return genefile_2; }
  string get_opt_file()    { return opt_file; }
  string get_clus_file()   { return clus_file; }
  string get_iso_file()    { return iso_file; }
  string get_non_iso_file(){ return non_iso_file; }
  string get_detail_file() { return detail_file; }
  string get_stat_file()   { return stat_file; }
  double get_col_index()   { return col_index; }
  unsigned get_t_dpd()     { return t_dpd; }
  void   print();
  void   print( string outfile );
};

#endif // __INC_DPD_OPTIONS_H__
