// *************************************************************************
//  file.cpp
// *************************************************************************

#include "file.h"
using namespace std;

// *************************************************************************
// Class hitfile
// Read file and return ...
void 
hit_file::read_file( gene_set& gs1, gene_set& gs2, hit_set& hs, string f ) {
  try {
    ifstream ifs(f.c_str());
    if( ifs.fail() )
      throw (string)"File open error: " + f.c_str();
    string str;
    while( getline(ifs, str) ){
      istringstream iss(str);
      string l;
      iss >> l;
      gene g1(l);
      iss >> l;
      gene g2(l);
      iss >> l;
      double bit = atof(l.c_str());
      gs1.insert( g1.get_ID(), g1 );
      gs2.insert( g2.get_ID(), g2 );
      hit hit( g1.get_ID(), g2.get_ID(), bit );
      hs.insert( hit.get_IDpair(), hit );
    }
    ifs.close();
  } catch ( string err_msg ){
    cerr << err_msg << endl; 
    exit(-1);
  }
}
