// *************************************************************************
//  gene.cpp
// *************************************************************************

#include "gene.h"


// *************************************************************************
// Class gene
// Constructor
gene::gene( string s, string delim ){
  list<string> str_list = split(s, delim);
  if( str_list.size() != 5 )
      throw "Inappropriate file format: " + s;
  list<string>::iterator it = str_list.begin();
  id = *it;  it++;
  loc.set_chr( *it ); it++;
  loc.set_stt( atof((*it).c_str()) ); it++;
  loc.set_end( atof((*it).c_str()) ); it++;
  string tmp_sgn = (*it);
  if( tmp_sgn == (string)"1" ){
    loc.set_sgn( true );
  } else if( tmp_sgn == (string)"-1" ){
    loc.set_sgn( false );
  } else {
    cerr << "warning: Wrong gene sign is found." << endl;
    exit(1);
  }
}


// *************************************************************************
// Class gene
// Return gene information by string
string gene::get_str( string delim ){
  return id + delim + loc.get_str( delim );
}


