#ifndef __INC_GENE_SET_H__
#define __INC_GENE_SET_H__

#include <list>
#include <map>
#include <string>
#include "c_hit_set.h"
#include "gene.h"
#include "util.h"

using namespace std;

class gene_set {
  map<string, gene> ID2gene;
  map<string, unsigned> chr2id;
  unsigned next_id();
 public:
  gene_set(){}
  gene_set( string in_file );
  void insert( gene g );
  void insert( string id, gene g );
  unsigned int size(){ return (unsigned int)ID2gene.size(); }
  map<string, gene>::iterator begin(){ return ID2gene.begin(); }
  map<string, gene>::iterator end()  { return ID2gene.end();   }
  map<string, gene>::iterator find(string s) { return ID2gene.find(s); }
  gene get_gene(string s);
  string get_str( string s, string delim = " " );
  string get_locus( string s, string delim = " " );
  void print_IDs();
  void print_strs();
  void print( string outfile, string delim = "\t" );
  void clear() { ID2gene.clear(); }
};

gene_set genes_in_hit_set( c_hit_set& c_hs, gene_set& gs, bool flg );


#endif // __INC_GENE_SET_H__
