// *************************************************************************
//  group.cpp
// *************************************************************************

#include "group.h"


// *************************************************************************
// Class group
// Constructor
group::group( string str1, string str2 ){
  id1_list = split( str1, "," );
  id2_list = split( str2, "," );
}


// *************************************************************************
// Class group
// Return the first pair
string group::first_pair(){
  list<string>::iterator it1 = id1_list.begin();
  list<string>::iterator it2 = id2_list.begin();
  string str1 = *it1;
  string str2 = *it2;
  string id_pair = str1 + ' ' + str2;
  return id_pair;
}


// *************************************************************************
// Class group
// Return all gene pairs 
c_hit_set group::get_all_gene_pairs(){
  hit_set   hs_12 = get_all_gene_pairs( true );
  hit_set   hs_21 = get_all_gene_pairs( false );
  c_hit_set c_hs( hs_12, hs_21 );
  return c_hs;
}


// *************************************************************************
// Class group
// Return all gene pairs 
hit_set group::get_all_gene_pairs( bool flg ){
  hit_set hs;
  list<string>::iterator it1, it2, it1_end, it2_end;
  if( flg ){
    it1 = id1_list.begin(); it1_end = id1_list.end();
    it2 = id2_list.begin(); it2_end = id2_list.end();
  } else {
    it1 = id2_list.begin(); it1_end = id2_list.end();
    it2 = id1_list.begin(); it2_end = id1_list.end();
  }
  double dummy_score = 0.0;
  while( it1 != it1_end ){
    string id1 = *it1;
    if( flg ) it2 = id2_list.begin();
    else      it2 = id1_list.begin();
    while( it2 != it2_end ){
      string id2 = *it2;
      hs.insert( id1, id2, dummy_score );
      ++it2;
    }
    ++it1;
  }
  return hs;
}
