#ifndef __INC_GROUP_SET_H__
#define __INC_GROUP_SET_H__

#include <map>
#include "gene_set.h"
#include "c_hit_set.h"
#include "position_map.h"
#include "position_2d_map.h"
#include "ortholog_set.h"
#include "oasys_hit_set.h"
#include "group.h"
#include "util.h"

using namespace std;

class group_set {
  map<unsigned, group> id2group;
  map<string, double> ip2wnnso;
 public:
  void load( string in_file );
  ortholog_set extract_seed_set();
  ortholog_set extract_ortholog_set( position_2d_map& pos_2d_map, 
				     ortholog_set& os, double col_index, 
				     double sds, double t_dpd);

  void insert( unsigned id, group gr );
  void erase( unsigned id ){ id2group.erase(id); }
  map<unsigned, group>::iterator begin() { return id2group.begin(); }
  map<unsigned, group>::iterator end()   { return id2group.end(); }
  map<unsigned, group>::iterator find( unsigned u ){ return id2group.find(u); }
  void w_insert( string id_pair, double wnnso );
  void w_erase( string id_pair ){ ip2wnnso.erase(id_pair); }
  map<string, double>::iterator w_begin() { return ip2wnnso.begin(); }
  map<string, double>::iterator w_end() { return ip2wnnso.end(); }
  map<string, double>::iterator w_find( string ip ){return ip2wnnso.find(ip);}

  c_hit_set get_all_gene_pairs();
  unsigned size() { return id2group.size(); }

  void print_info( string outfile );
};

#endif // __INC_GROUP_SET_H__
