#ifndef __INC_HIT_SET_H__
#define __INC_HIT_SET_H__

#include <map>
#include <string>
#include <stdlib.h>
#include "hit.h"

using namespace std;

class hit_set {
  map<string, hit> IDpair2hit;
 public:
  hit_set(){}
  hit_set( string in_file );
  void insert(string ip, hit h);
  void insert(string ip, double d);
  void insert(string id1, string id2, double d);
  void erase( string ip );
  map<string, hit>::iterator begin(){ return IDpair2hit.begin(); }
  map<string, hit>::iterator end(){ return IDpair2hit.end(); }
  map<string, hit>::iterator find( string ip ){ return IDpair2hit.find( ip ); }
  bool exist( string ip );
  unsigned int size() { return (unsigned int)IDpair2hit.size(); }
  void print_IDpairs();
  void clear(){ IDpair2hit.clear(); }
};


#endif // __INC_HIT_SET_H__
