// *************************************************************************
//  locus.cpp
// *************************************************************************

#include "locus.h"
using namespace std;

// *************************************************************************
// Class locus
// Return locus information by string
string locus::get_str( string delim ) {
  string stt_str = int2string( (int)stt );
  string end_str = int2string( (int)end );
  string sgn_str;
  if(sgn){ sgn_str=(string)"1"; }
  else   { sgn_str=(string)"-1"; }
  string str = chr + delim + stt_str + delim + end_str + delim + sgn_str;
  return str;
}


// *************************************************************************
// Class locus
// Return locus information by string
string locus::get_str( map<string, unsigned>& chr2id, string delim ) {
  map<string, unsigned>::iterator it = chr2id.find( chr );
  if( it == chr2id.end() ){
    cerr << "Error: " << chr << " is not found." << endl;
    exit( -1 );
  }
  unsigned chr_id = it->second;
  string chr_str  = int2string( chr_id );
  string stt_str  = int2string( (int)stt );
  string end_str  = int2string( (int)end );
  string sgn_str;
  if(sgn){ sgn_str=(string)"+"; }
  else   { sgn_str=(string)"-"; }
  string str = chr_str + delim + stt_str + delim + end_str + delim + sgn_str;
  return str;
}
