// *************************************************************************
//  make_wnnso_matrix.cpp
// *************************************************************************

#include <ctime>
#include "make_wnnso_matrix.h"
#include "make_wnnso_options.h"
#include "seed_matrix.h"

// *************************************************************************
// main function.
int main( int argc, char* argv[] ){
  // Get options
  cerr << endl;
  cerr << "Getting options...";
  make_wnnso_options opt( argc, argv );
  opt.print();

  // Record start time
  time_t sttTime = time(0);

  // Insert the position of seeds
  cerr << "Inserting the position of seeds..." << endl;
  time_t   baseTime = time(0);
  unsigned n_cols   = opt.get_n_cols();
  unsigned n_rows   = opt.get_n_rows();
  string   seed_pos = opt.get_seed_pos();
  seed_matrix seed_mat( n_cols, n_rows, seed_pos );
  cerr << seed_mat.num_seeds() << " seeds were inserted." << endl;
  cerr << "done ("
       << time(0) - baseTime << " seconds)" << endl;
  cerr << endl;

  // Print seed matrix
  cerr << "Printing seed matrix..." << endl;
  string outfile = opt.get_out_file();
  seed_mat.show();
  seed_mat.print( outfile );
  cerr << "done ("
       << time(0) - baseTime << " seconds)" << endl;
  cerr << endl;
  
  // Report total time required for this program
  cerr << "Total time : " << time(0) - sttTime << " seconds" << endl;

  return 0;
}
