#ifndef __INC_OASYS_HIT_H__
#define __INC_OASYS_HIT_H__

#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include "c_hit.h"
#include "model.h"
#include "util.h"

class oasys_hit : public c_hit {
  double wnnso;
  double syn_score, mi_syn_score;
  double seq_score, mi_seq_score;
  double score, mi_score;
 public:
  oasys_hit( string l );
  oasys_hit( c_hit ch, double wn );
  oasys_hit( string id_pair, double bit, double wn );

  void set_wnnso( double d ) { wnnso = d; }
  void calc_syn_score( model& m1, model& m0 );
  void calc_mi_syn_score( model& m1, model& m0, double peak_val );
  void calc_seq_score( model& m1, model& m0 );
  void calc_mi_seq_score( model& m1, model& m0, double peak_val );
  void set_score( double w_ratio );
  void set_mi_score( double w_ratio );

  double get_wnnso() { return wnnso; }
  double get_syn_score() { return syn_score; }
  double get_mi_syn_score() { return mi_syn_score; }
  double get_seq_score() { return seq_score; }
  double get_mi_seq_score() { return mi_seq_score; }
  double get_score() { return score; }
  double get_mi_score() { return mi_score; }
};

#endif // __INC_OASYS_HIT_H__
