#ifndef __INC_OPTIONS_H__
#define __INC_OPTIONS_H__

#include <iostream>
#include <string>
#include <stdlib.h>
#include "util.h"

#ifndef INF
#define INF 0
#endif // INF
#define DEFAULT_COL_INDEX 1.0
#define DEFAULT_SDS 2.0
#define DEFAULT_T_DPD 10
#define DEFAULT_W_RATIO 1.0

using namespace std;

class options {
  string orgname_in1;
  string orgname_in2;
  string data_dir;
  string gene_dir;
  string genefile_1;
  string genefile_2;
  string hitfile_12;
  string hitfile_21;
  string group_file;
  string out_dir;
  string jobname;
  string opt_file;
  string wnnso_file;
  string oasys_hit_file;
  string bit_rbh_file;
  string wnnso_rbh_file;
  string oasys_rbh_file;
  string ortholog_file;
  double col_index; // collinearity index
  double sds;     // standard deviation squared
  double t_dpd;   // threshold for DPD
  double w_ratio; // weight ratio
  bool   flg_group;
  bool   flg_short_cut;
  bool   flg_plot;
  void   set_file_name();
 public:
  options( int argc, char* argv[] );
  string get_orgname_in1()       { return orgname_in1; }
  string get_orgname_in2()       { return orgname_in2; }
  string get_genefile_1()        { return genefile_1; }
  string get_genefile_2()        { return genefile_2; }
  string get_hitfile_12()        { return hitfile_12; }
  string get_hitfile_21()        { return hitfile_21; }
  string get_group_file()        { return group_file; }
  string get_data_dir()          { return data_dir; }
  string get_out_dir()           { return out_dir; }
  string get_jobname()           { return jobname; }
  string get_opt_file()          { return opt_file; }
  string get_wnnso_file()        { return wnnso_file; }
  string get_oasys_hit_file()    { return oasys_hit_file; }
  string get_bit_rbh_file()      { return bit_rbh_file; }
  string get_wnnso_rbh_file()    { return wnnso_rbh_file; }
  string get_oasys_rbh_file()    { return oasys_rbh_file; }
  string get_ortholog_file()     { return ortholog_file; }
  double get_col_index()         { return col_index; }
  double get_sds()               { return sds; }
  double get_t_dpd()             { return t_dpd; }
  double get_w_ratio()           { return w_ratio; }
  bool   get_flg_group()         { return flg_group; }
  bool   get_flg_short_cut()     { return flg_short_cut; }
  bool   get_flg_plot()          { return flg_plot; }
  void   print();
  void   print( string outfile );
};

#endif // __INC_OPTIONS_H__
