#ifndef __INC_PDF_H__
#define __INC_PDF_H__

#include <string>
#include <vector>
#include "param.h"
#include "histogram.h"

using namespace std;

class pdf {
 public:
  virtual ~pdf(){};
  virtual void set_param( void* par ) = 0;
  virtual void fit_ml( vector<double>& x ) = 0;
  virtual void fit_ml( vector<double>& x, vector<double>& w ) = 0;
  virtual double eval( double x ) = 0;
  virtual double log_L( vector<double>& x ) = 0;
  virtual double log_L( vector<double>& x, vector<double>& w ) = 0;
  virtual double log_dL( vector<double>& x ) = 0;
  virtual double log_dL( vector<double>& x, vector<double>& w ) = 0;
  virtual double aic( vector<double>& x ) = 0;
  virtual double aic( vector<double>& x, vector<double>& w ) = 0;
  virtual void print_sample_points( string file, double min, double max ) = 0;
  virtual void plot( string name ) = 0;
  virtual void plot( string name, vector<double>& x, size_t num_bin ) = 0;
  virtual void plot( string name, vector<double>& x, vector<double>& w, 
		     size_t num_bin ) = 0;
  virtual void plot( string name, histogram& h ) = 0;
  virtual void plot( string name, vector<void*>& param_list ) = 0;
};

#endif // __INC_PDF_H__
