#ifndef __INC_POSITION_LIST_H__
#define __INC_POSITION_LIST_H__

#include <vector>
#include <map>
#include "gene_set.h"

#ifndef DELTA
#define DELTA 0.001
#endif // DELTA

using namespace std;

class position_list {
  vector<string> pos2id;
  map<string, unsigned> id2pos;

  map<double, string> calc_coords2id( gene_set& gs );
  void id2pos_insert( string id, unsigned pos )
  { id2pos.insert( map<string, unsigned>::value_type( id, pos ) ); }
 public:
  position_list( gene_set& gs );
  map<string, unsigned>::iterator id2pos_begin() { return id2pos.begin(); }
  map<string, unsigned>::iterator id2pos_end() { return id2pos.end(); }
  map<string, unsigned>::iterator id2pos_find( string id )
  { return id2pos.find( id ); }
  unsigned get_pos( string id );
  unsigned size() { return pos2id.size(); }
};


#endif // __INC_POSITION_LIST_H__
