#ifndef __INC_TOP_HIT_SET_H__
#define __INC_TOP_HIT_SET_H__

#include <string>
#include <map>
#include "c_hit_set.h"

using namespace std;

class top_hit_set {
  map<string, string> id2best_id;
  map<string, double> id2best_bit;
  map<string, double> id2fs_rate;
  map<string, bool> rev_flag;

  void erase_bit( string id ) { id2best_bit.erase( id ); }
  void insert_bit( string id, double bit )
  { id2best_bit.insert( map<string, double>::value_type( id, bit ) ); }
  void erase_fs( string id ) { id2fs_rate.erase( id ); }
  void insert_fs( string id, double fs ) 
  { id2fs_rate.insert( map<string, double>::value_type( id, fs ) ); }
  void erase_id( string id ) { id2best_id.erase( id ); }
  void insert_id( string id1, string id2 ) 
  { id2best_id.insert( map<string, string>::value_type( id1, id2 ) ); }
  void rev_erase( string id ) { rev_flag.erase( id ); }
  void rev_insert( string id, bool flg ) 
  { rev_flag.insert( map<string, bool>::value_type( id, flg ) ); }
 public:
  top_hit_set( c_hit_set& c_hs, bool b );
  ~top_hit_set(){ 
    id2best_id.clear();  
    id2best_bit.clear();
    id2fs_rate.clear();
    rev_flag.clear();
  }

  map<string, string>::iterator begin_id() { return id2best_id.begin(); }
  map<string, string>::iterator end_id() { return id2best_id.end(); }
  map<string, string>::iterator find_id( string id )
    { return id2best_id.find( id ); }

  map<string, double>::iterator begin_bit() { return id2best_bit.begin(); }
  map<string, double>::iterator end_bit() { return id2best_bit.end(); }
  map<string, double>::iterator find_bit( string id ) 
  { return id2best_bit.find( id ); }

  map<string, double>::iterator begin_fs() { return id2fs_rate.begin(); }
  map<string, double>::iterator end_fs() { return id2fs_rate.end(); }
  map<string, double>::iterator find_fs( string id )
  { return id2fs_rate.find( id ); }

  map<string, bool>::iterator rev_begin() { return rev_flag.begin(); }
  map<string, bool>::iterator rev_end() { return rev_flag.end(); }
  map<string, bool>::iterator rev_find( string id )
    { return rev_flag.find( id ); }

  double get_bit( string id ) { return find_bit(id)->second; }
  bool exist( string id ) { return find_id(id) == end_id() ? false : true; }
  bool rev_exist( string id ) 
  { return rev_find(id) == rev_end() ? false : true; }

  void print_bit( string outfile );
  void print_fs( string outfile );

  unsigned size() { return id2best_id.size(); }
  void clear() { id2best_id.clear(); id2best_bit.clear(); rev_flag.clear(); }
};

map<string, unsigned int> top_count( top_hit_set& t_hs );
unsigned int top_count( map<string, unsigned int>& id2cnt, string id );

#endif // _INC_TOP_HIT_SET_H__
